diff --git a/part/part.cpp b/part/part.cpp
index be4aeaa..dc286cb 100644
--- a/part/part.cpp
+++ b/part/part.cpp
@@ -274,12 +274,19 @@ void Part::updateActions()
         m_extractFilesAction->setMenu(m);
         connect(m, SIGNAL(triggered(QAction*)),
                 this, SLOT(slotQuickExtractFiles(QAction*)));
+
+        QAction *a_extractTo = m->addAction(i18n("Extract To..."));
+        a_extractTo->setIcon(m_extractFilesAction->icon());
+        a_extractTo->setStatusTip(m_extractFilesAction->statusTip());
+        connect(a_extractTo, SIGNAL(triggered(bool)),
+                this, SLOT(slotExtractFiles()));
+
         QAction *header = m->addAction(i18n("Quick Extract To..."));
         header->setEnabled(false);
         header->setIcon(KIcon("archive-extract"));
     }
 
-    while (m->actions().size() > 1) {
+    while (m->actions().size() > 2) {
         m->removeAction(m->actions().last());
     }
 
@@ -294,28 +301,30 @@ void Part::updateActions()
 
 void Part::slotQuickExtractFiles(QAction *triggeredAction)
 {
-    kDebug() << "Extract to " << triggeredAction->data().toString();
+    if (!triggeredAction->data().isNull()) {
+        kDebug() << "Extract to " << triggeredAction->data().toString();
 
-    const QString userDestination = triggeredAction->data().toString();
-    QString finalDestinationDirectory;
-    const QString detectedSubfolder = detectSubfolder();
+        const QString userDestination = triggeredAction->data().toString();
+        QString finalDestinationDirectory;
+        const QString detectedSubfolder = detectSubfolder();
 
-    if (!isSingleFolderArchive()) {
-        finalDestinationDirectory = userDestination +
-                                    QDir::separator() + detectedSubfolder;
-        QDir(userDestination).mkdir(detectedSubfolder);
-    } else finalDestinationDirectory = userDestination;
+        if (!isSingleFolderArchive()) {
+            finalDestinationDirectory = userDestination +
+                                        QDir::separator() + detectedSubfolder;
+            QDir(userDestination).mkdir(detectedSubfolder);
+        } else finalDestinationDirectory = userDestination;
 
-    Kerfuffle::ExtractionOptions options;
-    options["PreservePaths"] = true;
-    QList<QVariant> files = selectedFiles();
-    ExtractJob *job = m_model->extractFiles(files, finalDestinationDirectory, options);
-    registerJob(job);
+        Kerfuffle::ExtractionOptions options;
+        options["PreservePaths"] = true;
+        QList<QVariant> files = selectedFiles();
+        ExtractJob *job = m_model->extractFiles(files, finalDestinationDirectory, options);
+        registerJob(job);
 
-    connect(job, SIGNAL(result(KJob*)),
-            this, SLOT(slotExtractionDone(KJob *)));
+        connect(job, SIGNAL(result(KJob*)),
+                this, SLOT(slotExtractionDone(KJob *)));
 
-    job->start();
+        job->start();
+    }
 
 }
 
